--- i386/libsaio/nvidia.c.orig	2012-12-16 11:44:04.000000000 +0100
+++ i386/libsaio/nvidia.c	2012-12-16 11:50:08.000000000 +0100
@@ -1608,22 +1608,26 @@
 			}
 		}
 	}
+
 	// At last try the generic names
 	for (i = 1; i < (sizeof(nvidia_card_generic) / sizeof(nvidia_card_generic[0])); i++)
 	{
         	if (nvidia_card_generic[i].device == device_id)
 		{
-			if (!subsys_id) return nvidia_card_generic[i].name;
-			for (j = 0; j < (sizeof(nvidia_card_vendors) / sizeof(nvidia_card_vendors[0])); j++)
+			if (subsys_id)
 			{
-				if (nvidia_card_vendors[j].device == (subsys_id & 0xffff0000))
+				for (j = 0; j < (sizeof(nvidia_card_vendors) / sizeof(nvidia_card_vendors[0])); j++)
 				{
-					sprintf(name_model, "%s %s",
-						nvidia_card_vendors[j].name, nvidia_card_generic[i].name);
-					name_model[sizeof(name_model) - 1] = '\0';
-					return name_model;
+					if (nvidia_card_vendors[j].device == (subsys_id & 0xffff0000))
+					{
+						sprintf(name_model, "%s %s",
+							nvidia_card_vendors[j].name, nvidia_card_generic[i].name);
+						name_model[sizeof(name_model) - 1] = '\0';
+						return name_model;
+					}
 				}
 			}
+			return nvidia_card_generic[i].name;
 		}
 	}
 	return nvidia_card_generic[0].name;
